mod test_utils;

use test_utils::spawn_app;

#[tokio::test]
async fn health_check_works() {
    let test_app = spawn_app().await;

    let client = reqwest::Client::new();

    let response = client
        .get(&format!("{}/health_check", &test_app.address))
        .send()
        .await
        .expect("Failed to execute health_check request.");

    assert!(response.status().is_success());
    assert_eq!(Some(0), response.content_length());
}
